<?php
// Content Management System module for PHProjekt (CMS4P).
// Copyright 2002-2005 by Mario A. Valdez-Ramirez
// http://www.mariovaldez.net/

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, 
// Boston, MA 02111-1307, USA.

// You can contact Mario A. Valdez-Ramirez by email 
// at mario@mariovaldez.org or paper mail at 
// Olmos 809, San Nicolas, NL. 66495, Mexico.

//session_start();
$file = "adm_config";
$path_pre = "../";
$include_path = $path_pre . "lib/lib.inc.php";
include_once $include_path;


$cm_configfile = "cm_config.inc.php";
$cm_defaultsuperuser = "root1";
$cm_codebaseversion = "0.6.0";
$cm_skinpath = $path_pre."cm/layout";


// fcm_yn_menu
// Display a Yes/No drop-down menu for a form.
function fcm_yn_menu ($cm_ynm_default, $cm_ynm_current, $cm_ynm_name, $cm_ynm_yesstr, $cm_ynm_nostr) {
  $cm_yes_sel =  "";
  $cm_no_sel = "";
  $cm_control_str = "";
  if ($cm_ynm_current == 1) {
    $cm_yes_sel =  "selected";
  }
  elseif ($cm_ynm_current == 0) {
    $cm_no_sel =  "selected";
  }
  elseif ($cm_ynm_default == 1) {
    $cm_yes_sel =  "selected";
  }
  elseif ($cm_ynm_default == 0) {
    $cm_no_sel =  "selected";
  }
  $cm_control_str .= "<select class=\"cms\" name=\"$cm_ynm_name\">\n";
  $cm_control_str .= "<option class=\"cms\" value=\"1\" $cm_yes_sel>$cm_ynm_yesstr</option>\n";
  $cm_control_str .= "<option class=\"cms\" value=\"0\" $cm_no_sel>$cm_ynm_nostr</option>\n";
  $cm_control_str .= "</select>\n";
  return ($cm_control_str);
}


// fcm_skin_menu
// Display a skin drop-down menu for a form.
function fcm_skin_menu ($cm_skm_default, $cm_skm_current, $cm_skm_name, $cm_skm_dir) {
  $cm_control_str = "";
  $cm_sorteddir = array ();
  $cm_dirhandle = opendir ($cm_skm_dir);
  while (($file = readdir ($cm_dirhandle)) !== false)
    $cm_sorteddir[count ($cm_sorteddir)] = $file;
	closedir ($cm_dirhandle);
  natcasesort ($cm_sorteddir);
  $cm_control_str .= "<select class=\"cms\" name=\"$cm_skm_name\">\n";
  $cm_control_str .= "<option class=\"cms\" value=\"\"></option>\n";
  foreach ($cm_sorteddir as $file) {
    if ($file != "." && $file != ".." && is_dir ($cm_skm_dir . "/" . $file)) {
      $cm_control_str .= "<option class=\"cms\" value=\"$file\"";
      if (($file == $cm_skm_current) || (($file == $cm_skm_default) && (!$cm_skm_current))) {
        $cm_control_str .= " selected";
      };
      $cm_control_str .= ">$file</option>\n";
    }
  }
  $cm_control_str .= "</select>\n";
  return ($cm_control_str);
}


// fcm_chk_cfgval
// Verify that a config value is valid.
function fcm_chk_cfgval ($cm_current_val, $cm_default_val) {
  if (isset ($cm_default_val)) {
    if (isset ($cm_current_val)) {
      if (is_numeric ($cm_default_val))
        return is_numeric ($cm_current_val) ? $cm_current_val : $cm_default_val;
      if (is_string ($cm_default_val))
        return is_string ($cm_current_val) ? $cm_current_val : $cm_default_val;
    }
    else {
      return ($cm_default_val);
    }
  }
}


// fcm_unhtmlentities_l
// This function is the inverse of the PHP's htmlentities function.
function fcm_unhtmlentities_l ($string) {
	$trans_tbl = get_html_translation_table (HTML_ENTITIES);
	$trans_tbl = array_flip ($trans_tbl);
	return strtr ($string, $trans_tbl);
};


echo "<html><head><title>Content management.</title><link rel=stylesheet type=\"text/css\" href=\"cm-style.css\"></head>
<body bgcolor=\"#FFFFFF\" leftmargin=\"20\" topmargin=\"20\" rightmargin=\"20\" bottommargin=\"20\">";


// Load language strings file.
$cm_langpath = "lang";
$cm_languages = array ("es" => 1, "en" => 1, "nl" => 1, "de" => 1, "fr" => 1, "ct" => 1, "br" => 1);
if (array_key_exists (strtolower ($langua), $cm_languages)) {
	$cm_langua = strtolower ($langua);
	include("$cm_langpath/$cm_langua.inc.php");
}
else { $cm_langua = "en"; include("$cm_langpath/en.inc.php"); }

if ($cmru) {
  echo "<p class=\"setupreturn\"><a class=\"cms\"href=\"" . $cmru . ".php\">{$cm_text["setup-return"]}</a></p>";
}

$cm_setup_error = false;
if ((!$cm_setup) && (!$cm_cancel)) {
  // try to load config file...
  if (is_readable ("$cm_configfile")) {
    include ("$cm_configfile");
  }
  else { 
    echo "<p class=\"generaltext\">{$cm_text["setup-cannotread"]}</p>";
  }
  // try to check if config file is loaded and valid...
  if ($cm_mainroot && $cm_currentversion) {
    if (($cm_superuser) && ($cm_superuser != $user_kurz)) {
      echo "<p class=\"titletext\">{$cm_text["setup-welcome"]}</p>";
      echo "<p class=\"generaltext\">{$cm_text["setup-currentuser"]} <strong>$user_kurz</strong><br>";
      echo "{$cm_text["setup-superuseris"]} <strong>$cm_superuser</strong></p>";
      echo "<h3 class=\"setuperror\">{$cm_text["setup-nosuperuser"]}</h3>";
      $cm_setup_error = true;
    }
    // check all values...
    $cm_remoteroot = fcm_chk_cfgval ($cm_remoteroot, 0);
    $cm_show_rootinnav = fcm_chk_cfgval ($cm_show_rootinnav, 0);
    $cm_enable_dbprefix = fcm_chk_cfgval ($cm_enable_dbprefix, 1);
    $cm_enable_htmledit = fcm_chk_cfgval ($cm_enable_htmledit, 0);
    $cm_enable_visedit = fcm_chk_cfgval ($cm_enable_visedit, 0);
    $cm_enable_platfonts = fcm_chk_cfgval ($cm_enable_platfonts, 1);
    $cm_enable_cleanhtml = fcm_chk_cfgval ($cm_enable_cleanhtml, 0);
    $cm_enable_verifylogo = fcm_chk_cfgval ($cm_enable_verifylogo, 1);
    $cm_historical_ratings = fcm_chk_cfgval ($cm_historical_ratings, 1);
    $cm_historical_comments = fcm_chk_cfgval ($cm_historical_comments, 1);
    $cm_comments_chronorder = fcm_chk_cfgval ($cm_comments_chronorder, 1);
    $cm_can_rerate = fcm_chk_cfgval ($cm_can_rerate, 0);
    $cm_enable_pngfix = fcm_chk_cfgval ($cm_enable_pngfix, 1);
    $cm_enable_gd = fcm_chk_cfgval ($cm_enable_gd, 1);
    $cm_jpeg_truecolors = fcm_chk_cfgval ($cm_jpeg_truecolors, 1);
    $cm_jpeg_quality = fcm_chk_cfgval ($cm_jpeg_quality, 75);
    $cm_jpegprefix_file = fcm_chk_cfgval ($cm_jpegprefix_file, "cmtn-");
    $cm_jpeg_maxX = fcm_chk_cfgval ($cm_jpeg_maxX, 125);
    $cm_jpeg_maxY = fcm_chk_cfgval ($cm_jpeg_maxY, 100);
    $cm_album_cols = fcm_chk_cfgval ($cm_album_cols, 3);
    $cm_jpeg_prettynames = fcm_chk_cfgval ($cm_jpeg_prettynames, 1);
    $cm_show_thumbsinlisting = fcm_chk_cfgval ($cm_show_thumbsinlisting, 0);
    $cm_dirs_inlisting = fcm_chk_cfgval ($cm_dirs_inlisting, 0);
    $cm_text_icons = fcm_chk_cfgval ($cm_text_icons, 0);
    $cm_home_maxleafs = fcm_chk_cfgval ($cm_home_maxleafs, 5);
    $cm_home_minleafs = fcm_chk_cfgval ($cm_home_minleafs, 0);
    $cm_home_oldestleafallowed = fcm_chk_cfgval ($cm_home_oldestleafallowed, 60);
    $cm_sum_oldestleafallowed = fcm_chk_cfgval ($cm_sum_oldestleafallowed, 10);
    $cm_max_statlist = fcm_chk_cfgval ($cm_max_statlist, 10);
    $cm_max_usercomments = fcm_chk_cfgval ($cm_max_usercomments, 25);
    $cm_resethits_aftercomment = fcm_chk_cfgval ($cm_resethits_aftercomment, 1);
    $cm_max_searchres = fcm_chk_cfgval ($cm_max_searchres, 10);
    $cm_default_skin = fcm_chk_cfgval ($cm_default_skin, "cm_gnome");
    $cm_force_skin = fcm_chk_cfgval ($cm_force_skin, 0);
    $cm_convert_emoticons = fcm_chk_cfgval ($cm_convert_emoticons, 1);
    $cm_control_iconwidth = fcm_chk_cfgval ($cm_control_iconwidth, 16);
    $cm_control_iconheight = fcm_chk_cfgval ($cm_control_iconheight, 16);
    $cm_setup_iconwidth = fcm_chk_cfgval ($cm_setup_iconwidth, 32);
    $cm_setup_iconheight = fcm_chk_cfgval ($cm_setup_iconheight, 32);
    $cm_msg_iconwidth = fcm_chk_cfgval ($cm_msg_iconwidth, 48);
    $cm_msg_iconheight = fcm_chk_cfgval ($cm_msg_iconheight, 48);
    $cm_emoticon_iconwidth = fcm_chk_cfgval ($cm_emoticon_iconwidth, 16);
    $cm_emoticon_iconheight = fcm_chk_cfgval ($cm_emoticon_iconheight, 16);
    $cm_filelist_iconwidth = fcm_chk_cfgval ($cm_filelist_iconwidth, 36);
    $cm_filelist_iconheight = fcm_chk_cfgval ($cm_filelist_iconheight, 36);
    $cm_dirlist_iconwidth = fcm_chk_cfgval ($cm_dirlist_iconwidth, 16);
    $cm_dirlist_iconheight = fcm_chk_cfgval ($cm_dirlist_iconheight, 16);
    $cm_doclogo_width = fcm_chk_cfgval ($cm_doclogo_width, 48);
    $cm_doclogo_height = fcm_chk_cfgval ($cm_doclogo_height, 48);
  }
  else {
    // if there is not config file, set default values...
    echo "<p class=\"generaltext\">{$cm_text["setup-loadingdefs"]}</p>";
    $cm_currentversion = $cm_codebaseversion;
    $cm_superuser = $cm_defaultsuperuser;
    $cm_mainroot = "root";
    $cm_remoteroot = 0;
    $cm_show_rootinnav = 0;
    $cm_enable_dbprefix = 1;
    $cm_enable_htmledit = 0;
    $cm_enable_visedit = 0;
    $cm_enable_platfonts = 1;
    $cm_enable_cleanhtml = 0;
    $cm_enable_verifylogo = 1;
    $cm_historical_ratings = 1;
    $cm_historical_comments = 1;
    $cm_comments_chronorder = 1;
    $cm_can_rerate = 0;
    $cm_enable_pngfix = 1;
    $cm_enable_gd = 1;
    $cm_jpeg_truecolors = 1;
    $cm_jpeg_quality = 75;
    $cm_jpegprefix_file = "cmtn-";
    $cm_jpeg_maxX = 125;
    $cm_jpeg_maxY = 100;
    $cm_album_cols = 3;
    $cm_jpeg_prettynames = 1;
    $cm_show_thumbsinlisting = 0;
    $cm_dirs_inlisting = 0;
    $cm_text_icons = 0;
    $cm_home_maxleafs = 5;
    $cm_home_minleafs = 0;
    $cm_home_oldestleafallowed = 60;
    $cm_sum_oldestleafallowed = 10;
    $cm_max_statlist = 10;
    $cm_max_usercomments = 25;
    $cm_resethits_aftercomment = 1;
    $cm_max_searchres = 10;
    $cm_default_skin = "cm_gnome";
    $cm_force_skin = 0;
    $cm_convert_emoticons = 1;
    $cm_control_iconwidth = 16;
    $cm_control_iconheight = 16;
    $cm_setup_iconwidth = 32;
    $cm_setup_iconheight = 32;
    $cm_msg_iconwidth = 48;
    $cm_msg_iconheight = 48;
    $cm_emoticon_iconwidth = 16; 
    $cm_emoticon_iconheight = 16;
    $cm_filelist_iconwidth = 36;
    $cm_filelist_iconheight = 36;
    $cm_dirlist_iconwidth = 16;
    $cm_dirlist_iconheight = 16;
    $cm_doclogo_width = 48;
    $cm_doclogo_height = 48;
  }
}

if (!$cm_setup_error) {
  if ($cm_setup) {
    // if saving, store values to config file...
    $cm_config_content = "<" . "?" . "php
    \$cm_currentversion = \"$cm_codebaseversion\";
    // {$cm_text["setup-superuser"]}
    \$cm_superuser = \"$cm_superuser\";
    // {$cm_text["setup-mainroot"]}
    \$cm_mainroot = \"$cm_mainroot\";
    // {$cm_text["setup-remoteroot"]}
    \$cm_remoteroot = \"$cm_remoteroot\";
    // {$cm_text["setup-show_rootinnav"]}
    \$cm_show_rootinnav = $cm_show_rootinnav;
    // {$cm_text["setup-enable_dbprefix"]}
    \$cm_enable_dbprefix = $cm_enable_dbprefix;
    // {$cm_text["setup-enable_htmledit"]}
    \$cm_enable_htmledit = $cm_enable_htmledit;
    // {$cm_text["setup-enable_visedit"]}
    \$cm_enable_visedit = $cm_enable_visedit;
    // {$cm_text["setup-enable_platfonts"]}
    \$cm_enable_platfonts = $cm_enable_platfonts;
    // {$cm_text["setup-enable_cleanhtml"]}
    \$cm_enable_cleanhtml = $cm_enable_cleanhtml;
    // {$cm_text["setup-enable_verifylogo"]}
    \$cm_enable_verifylogo = $cm_enable_verifylogo;
    // {$cm_text["setup-historical_ratings"]}
    \$cm_historical_ratings = $cm_historical_ratings;
    // {$cm_text["setup-historical_comments"]}
    \$cm_historical_comments = $cm_historical_comments;
    // {$cm_text["setup-comments_chronorder"]}
    \$cm_comments_chronorder = $cm_comments_chronorder;
    // {$cm_text["setup-can_rerate"]}
    \$cm_can_rerate = $cm_can_rerate;
    // {$cm_text["setup-enable_pngfix"]}
    \$cm_enable_pngfix = $cm_enable_pngfix;
    // {$cm_text["setup-enable_gd"]}
    \$cm_enable_gd = $cm_enable_gd;
    // {$cm_text["setup-jpeg_truecolors"]}
    \$cm_jpeg_truecolors = $cm_jpeg_truecolors;
    // {$cm_text["setup-jpeg_quality"]}
    \$cm_jpeg_quality = $cm_jpeg_quality;
    // {$cm_text["setup-jpegprefix_file"]}
    \$cm_jpegprefix_file = \"$cm_jpegprefix_file\";
    // {$cm_text["setup-jpeg_size"]}
    \$cm_jpeg_maxX = $cm_jpeg_maxX;
    \$cm_jpeg_maxY = $cm_jpeg_maxY;
    // {$cm_text["setup-album_cols"]}
    \$cm_album_cols = $cm_album_cols;
    // {$cm_text["setup-jpeg_prettynames"]}
    \$cm_jpeg_prettynames = $cm_jpeg_prettynames;
    // {$cm_text["setup-show_thumbsinlisting"]}
    \$cm_show_thumbsinlisting = $cm_show_thumbsinlisting;
    // {$cm_text["setup-dirs_inlisting"]}
    \$cm_dirs_inlisting = $cm_dirs_inlisting;
    // {$cm_text["setup-text_icons"]}
    \$cm_text_icons = $cm_text_icons;
    // {$cm_text["setup-home_maxleafs"]}
    \$cm_home_maxleafs = $cm_home_maxleafs;
    // {$cm_text["setup-home_minleafs"]}
    \$cm_home_minleafs = $cm_home_minleafs;
    // {$cm_text["setup-home_oldestleafallowed"]}
    \$cm_home_oldestleafallowed = $cm_home_oldestleafallowed;
    // {$cm_text["setup-sum_oldestleafallowed"]}
    \$cm_sum_oldestleafallowed = $cm_sum_oldestleafallowed;
    // {$cm_text["setup-max_statlist"]}
    \$cm_max_statlist = $cm_max_statlist;
    // {$cm_text["setup-max_usercomments"]}
    \$cm_max_usercomments = $cm_max_usercomments;
    // {$cm_text["setup-resethits_aftercomment"]}
    \$cm_resethits_aftercomment = $cm_resethits_aftercomment;
    // {$cm_text["setup-max_searchres"]}
    \$cm_max_searchres = $cm_max_searchres;
    // {$cm_text["setup-default_skin"]}
    \$cm_default_skin = \"" . fcm_chk_cfgval ($cm_default_skin, "cm_gnome") . "\";
    // {$cm_text["setup-force_skin"]}
    \$cm_force_skin = $cm_force_skin;
    // {$cm_text["setup-convert_emoticons"]}
    \$cm_convert_emoticons = $cm_convert_emoticons;
    // {$cm_text["setup-images_controlsize"]}
    \$cm_control_iconwidth = $cm_control_iconwidth;
    \$cm_control_iconheight = $cm_control_iconheight;
    // {$cm_text["setup-images_setupsize"]}
    \$cm_setup_iconwidth = $cm_setup_iconwidth;
    \$cm_setup_iconheight = $cm_setup_iconheight;
    // {$cm_text["setup-images_messagesize"]}
    \$cm_msg_iconwidth = $cm_msg_iconwidth; 
    \$cm_msg_iconheight = $cm_msg_iconheight;
    // {$cm_text["setup-images_emoticonsize"]}
    \$cm_emoticon_iconwidth = $cm_emoticon_iconwidth; 
    \$cm_emoticon_iconheight = $cm_emoticon_iconheight;
    // {$cm_text["setup-images_filelistsize"]}
    \$cm_filelist_iconwidth = $cm_filelist_iconwidth;
    \$cm_filelist_iconheight = $cm_filelist_iconheight;
    // {$cm_text["setup-images_dirlistsize"]}
    \$cm_dirlist_iconwidth = $cm_dirlist_iconwidth;
    \$cm_dirlist_iconheight = $cm_dirlist_iconheight;
    // {$cm_text["setup-images_doclogosize"]}
    \$cm_doclogo_width = $cm_doclogo_width;
    \$cm_doclogo_height = $cm_doclogo_height;
    ?" . ">";
    $cm_config_content = fcm_unhtmlentities_l ($cm_config_content);
    $fp = @fopen ("$cm_configfile",'wb+');
    $fw = fwrite ($fp, $cm_config_content);
    if (!$fw) {
      echo "<p class=\"setuperror\">{$cm_text["setup-fileerror"]}</p>";
    }
    else {
      echo "<p class=\"titletext\">{$cm_text["setup-setupdone"]}</p>";
      echo "<pre>
        version = \"$cm_currentversion\";
        superuser = \"$cm_superuser\";
        mainroot = \"$cm_mainroot\";
        remoteroot = $cm_remoteroot;
        show_rootinnav = $cm_show_rootinnav;
        enable_dbprefix = $cm_enable_dbprefix;
        enable_htmledit = $cm_enable_htmledit;
        enable_visedit = $cm_enable_visedit;
        enable_platfonts = $cm_enable_platfonts;
        enable_cleanhtml = $cm_enable_cleanhtml;
        enable_verifylogo = $cm_enable_verifylogo;
        historical_ratings = $cm_historical_ratings;
        historical_comments = $cm_historical_comments;
        comments_chronorder = $cm_comments_chronorder;
        can_rerate = $cm_can_rerate;
        enable_pngfix = $cm_enable_pngfix;
        enable_gd = $cm_enable_gd;
        jpeg_truecolors = $cm_jpeg_truecolors;
        jpeg_quality = $cm_jpeg_quality;
        jpegprefix_file = \"$cm_jpegprefix_file\";
        jpeg_maxX = $cm_jpeg_maxX;
        jpeg_maxY = $cm_jpeg_maxY;
        album_cols = $cm_album_cols;
        jpeg_prettynames = $cm_jpeg_prettynames;
        show_thumbsinlisting = $cm_show_thumbsinlisting;
        dirs_inlisting = $cm_dirs_inlisting;
        text_icons = $cm_text_icons;
        home_maxleafs = $cm_home_maxleafs;
        home_minleafs = $cm_home_minleafs;
        home_oldestleafallowed = $cm_home_oldestleafallowed;
        sum_oldestleafallowed = $cm_sum_oldestleafallowed;
        max_statlist = $cm_max_statlist;
        max_usercomments = $cm_max_usercomments;
        resethits_aftercomment = $cm_resethits_aftercomment;
        max_searchres = $cm_max_searchres;
        default_skin = $cm_default_skin;
        force_skin = $cm_force_skin;
        convert_emoticons = $cm_convert_emoticons;
        control_iconwidth = $cm_control_iconwidth;
        control_iconheight = $cm_control_iconheight;
        setup_iconwidth = $cm_setup_iconwidth;
        setup_iconheight = $cm_setup_iconheight;
        msg_iconwidth = $cm_msg_iconwidth;
        msg_iconheight = $cm_msg_iconheight;
        emoticon_iconwidth = $cm_emoticon_iconwidth; 
        emoticon_iconheight = $cm_emoticon_iconheight;
        filelist_iconwidth = $cm_filelist_iconwidth;
        filelist_iconheight = $cm_filelist_iconheight;
        dirlist_iconwidth = $cm_dirlist_iconwidth;
        dirlist_iconheight = $cm_dirlist_iconheight;
        doclogo_width = $cm_doclogo_width;
        doclogo_height = $cm_doclogo_height;
      </pre>";
    }
    fclose($fp);
  }
  elseif ($cm_cancel) {
    // if canceled...
    echo "<p class=\"titletext\">{$cm_text["setup-canceled"]}</p>";
  }
  else {
    // if not saving or cancel, we are configuring...
    echo "
    <p class=\"titletext\">($cm_currentversion &gt; $cm_codebaseversion)<br>\n
    {$cm_text["setup-welcome"]}</p>\n
    <p class=\"generaltext\">{$cm_text["setup-currentuser"]} <strong>$user_kurz</strong><br>\n
    {$cm_text["setup-superuseris"]} <strong>$cm_superuser</strong></p>\n
    <form class=\"cms\" action=\"adm_config.php\" method=\"post\">\n
    <input type=\"hidden\" name=\"cm_currentversion\" value=\"$cm_codebaseversion\">\n
    <input type=\"hidden\" name=\"cmru\" value=\"$cmru\">\n
    <input type=\"hidden\" name=\"cm_first_time\" value=\"$cm_first_time\">\n";

    echo "<table border=\"0\" align=\"center\" cellpadding=\"2\" cellspacing=\"0\"\n>";
    echo "<tr class=\"setupcolor2\"><td class=\"config1header\" align=\"center\" nowrap>{$cm_text["setup-curvalue"]}</td>\n";
    echo "<td class=\"config1header\" align=\"center\">{$cm_text["setup-defvalue"]}</td><td class=\"config1header\" align=\"center\">{$cm_text["setup-explanation"]}</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"superuser\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_superuser\" size=\"10\" maxlength=\"10\" value=\"$cm_superuser\">";
    echo "</td><td class=\"config1body2\">$cm_defaultsuperuser</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-superuser"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"mainroot\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_mainroot\" size=\"15\" maxlength=\"100\" value=\"$cm_mainroot\">";
    echo "</td><td class=\"config1body2\">root</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-mainroot"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"remoteroot\">\n";
    echo fcm_yn_menu (0, $cm_remoteroot, "cm_remoteroot", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-no"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-remoteroot"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"show_rootinnav\">\n";
    echo fcm_yn_menu (0, $cm_show_rootinnav, "cm_show_rootinnav", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-no"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-show_rootinnav"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"enable_dbprefix\">\n";
    echo fcm_yn_menu (1, $cm_enable_dbprefix, "cm_enable_dbprefix", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-enable_dbprefix"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"enable_htmledit\">\n";
    echo fcm_yn_menu (0, $cm_enable_htmledit, "cm_enable_htmledit", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-no"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-enable_htmledit"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"enable_visedit\">\n";
    echo fcm_yn_menu (0, $cm_enable_visedit, "cm_enable_visedit", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-no"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-enable_visedit"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"enable_platfonts\">\n";
    echo fcm_yn_menu (1, $cm_enable_platfonts, "cm_enable_platfonts", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-enable_platfonts"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"enable_cleanhtml\">\n";
    echo fcm_yn_menu (0, $cm_enable_cleanhtml, "cm_enable_cleanhtml", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-no"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-enable_cleanhtml"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"enable_verifylogo\">\n";
    echo fcm_yn_menu (1, $cm_enable_verifylogo, "cm_enable_verifylogo", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-enable_verifylogo"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"historical_ratings\">\n";
    echo fcm_yn_menu (1, $cm_historical_ratings, "cm_historical_ratings", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-historical_ratings"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"historical_comments\">\n";
    echo fcm_yn_menu (1, $cm_historical_comments, "cm_historical_comments", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-historical_comments"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"comments_chronorder\">\n";
    echo fcm_yn_menu (1, $cm_comments_chronorder, "cm_comments_chronorder", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-comments_chronorder"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"can_rerate\">\n";
    echo fcm_yn_menu (0, $cm_can_rerate, "cm_can_rerate", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-no"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-can_rerate"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"enable_pngfix\">\n";
    echo fcm_yn_menu (0, $cm_enable_pngfix, "cm_enable_pngfix", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-enable_pngfix"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"enable_gd\">\n";
    echo fcm_yn_menu (0, $cm_enable_gd, "cm_enable_gd", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-enable_gd"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"jpeg_truecolors\">\n";
    echo fcm_yn_menu (0, $cm_jpeg_truecolors, "cm_jpeg_truecolors", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-jpeg_truecolors"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"jpeg_quality\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_jpeg_quality\" size=\"6\" maxlength=\"10\" value=\"$cm_jpeg_quality\">";
    echo "</td><td class=\"config1body2\">75</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-jpeg_quality"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"jpegprefix_file\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_jpegprefix_file\" size=\"6\" maxlength=\"10\" value=\"$cm_jpegprefix_file\">";
    echo "</td><td class=\"config1body2\">cmtn-</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-jpegprefix_file"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"jpeg_size\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_jpeg_maxX\" size=\"6\" maxlength=\"10\" value=\"$cm_jpeg_maxX\">
          <input class=\"cms\" type=\"text\" name=\"cm_jpeg_maxY\" size=\"6\" maxlength=\"10\" value=\"$cm_jpeg_maxY\">";
    echo "</td><td class=\"config1body2\">125x100</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-jpeg_size"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"album_cols\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_album_cols\" size=\"6\" maxlength=\"10\" value=\"$cm_album_cols\">";
    echo "</td><td class=\"config1body2\">3</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-album_cols"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"jpeg_prettynames\">\n";
    echo fcm_yn_menu (0, $cm_jpeg_prettynames, "cm_jpeg_prettynames", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-jpeg_prettynames"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"show_thumbsinlisting\">\n";
    echo fcm_yn_menu (0, $cm_show_thumbsinlisting, "cm_show_thumbsinlisting", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-no"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-show_thumbsinlisting"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"dirs_inlisting\">\n";
    echo fcm_yn_menu (0, $cm_dirs_inlisting, "cm_dirs_inlisting", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-no"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-dirs_inlisting"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"text_icons\">\n";
    echo fcm_yn_menu (0, $cm_text_icons, "cm_text_icons", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-no"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-text_icons"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"home_maxleafs\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_home_maxleafs\" size=\"6\" maxlength=\"10\" value=\"$cm_home_maxleafs\">";
    echo "</td><td class=\"config1body2\">5</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-home_maxleafs"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"home_minleafs\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_home_minleafs\" size=\"6\" maxlength=\"10\" value=\"$cm_home_minleafs\">";
    echo "</td><td class=\"config1body2\">0</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-home_minleafs"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"home_oldestleafallowed\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_home_oldestleafallowed\" size=\"6\" maxlength=\"10\" value=\"$cm_home_oldestleafallowed\">";
    echo "</td><td class=\"config1body2\">60</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-home_oldestleafallowed"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"sum_oldestleafallowed\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_sum_oldestleafallowed\" size=\"6\" maxlength=\"10\" value=\"$cm_sum_oldestleafallowed\">";
    echo "</td><td class=\"config1body2\">10</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-sum_oldestleafallowed"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"max_statlist\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_max_statlist\" size=\"6\" maxlength=\"10\" value=\"$cm_max_statlist\">";
    echo "</td><td class=\"config1body2\">10</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-max_statlist"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"max_usercomments\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_max_usercomments\" size=\"6\" maxlength=\"10\" value=\"$cm_max_usercomments\">";
    echo "</td><td class=\"config1body2\">25</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-max_usercomments"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"resethits_aftercomment\">\n";
    echo fcm_yn_menu (0, $cm_resethits_aftercomment, "cm_resethits_aftercomment", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-resethits_aftercomment"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"max_searchres\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_max_searchres\" size=\"6\" maxlength=\"10\" value=\"$cm_max_searchres\">";
    echo "</td><td class=\"config1body2\">10</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-max_searchres"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"default_skin\">\n";
    echo fcm_skin_menu ("cm_gnome", $cm_default_skin, "cm_default_skin", $cm_skinpath);
    echo "</td><td class=\"config1body2\">cm_gnome</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-default_skin"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"force_skin\">\n";
    echo fcm_yn_menu (0, $cm_force_skin, "cm_force_skin", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-no"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-force_skin"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"convert_emoticons\">\n";
    echo fcm_yn_menu (1, $cm_convert_emoticons, "cm_convert_emoticons", $cm_text["setup-yes"], $cm_text["setup-no"]);
    echo "</td><td class=\"config1body2\">{$cm_text["setup-yes"]}</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-convert_emoticons"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"images_controlsize\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_control_iconwidth\" size=\"6\" maxlength=\"10\" value=\"$cm_control_iconwidth\">
          <input class=\"cms\" type=\"text\" name=\"cm_control_iconheight\" size=\"6\" maxlength=\"10\" value=\"$cm_control_iconheight\">";
    echo "</td><td class=\"config1body2\">16x16</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-images_controlsize"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"images_setupsize\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_setup_iconwidth\" size=\"6\" maxlength=\"10\" value=\"$cm_setup_iconwidth\">
          <input class=\"cms\" type=\"text\" name=\"cm_setup_iconheight\" size=\"6\" maxlength=\"10\" value=\"$cm_setup_iconheight\">";
    echo "</td><td class=\"config1body2\">32x32</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-images_setupsize"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"images_messagesize\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_msg_iconwidth\" size=\"6\" maxlength=\"10\" value=\"$cm_msg_iconwidth\">
          <input class=\"cms\" type=\"text\" name=\"cm_msg_iconheight\" size=\"6\" maxlength=\"10\" value=\"$cm_msg_iconheight\">";
    echo "</td><td class=\"config1body2\">48x48</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-images_messagesize"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"images_emoticonsize\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_emoticon_iconwidth\" size=\"6\" maxlength=\"10\" value=\"$cm_emoticon_iconwidth\">
          <input class=\"cms\" type=\"text\" name=\"cm_emoticon_iconheight\" size=\"6\" maxlength=\"10\" value=\"$cm_emoticon_iconheight\">";
    echo "</td><td class=\"config1body2\">16x16</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-images_emoticonsize"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"images_filelistsize\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_filelist_iconwidth\" size=\"6\" maxlength=\"10\" value=\"$cm_filelist_iconwidth\">
          <input class=\"cms\" type=\"text\" name=\"cm_filelist_iconheight\" size=\"6\" maxlength=\"10\" value=\"$cm_filelist_iconheight\">";
    echo "</td><td class=\"config1body2\">36x36</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-images_filelistsize"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor2\"><td class=\"config1body1\" align=\"right\" nowrap title=\"images_dirlistsize\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_dirlist_iconwidth\" size=\"6\" maxlength=\"10\" value=\"$cm_dirlist_iconwidth\">
          <input class=\"cms\" type=\"text\" name=\"cm_dirlist_iconheight\" size=\"6\" maxlength=\"10\" value=\"$cm_dirlist_iconheight\">";
    echo "</td><td class=\"config1body2\">16x16</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-images_dirlistsize"]} <br>";
    echo "</td></tr>\n";
    echo "<tr class=\"setupcolor1\"><td class=\"config1body1\" align=\"right\" nowrap title=\"images_doclogosize\">\n";
    echo "<input class=\"cms\" type=\"text\" name=\"cm_doclogo_width\" size=\"6\" maxlength=\"10\" value=\"$cm_doclogo_width\">
          <input class=\"cms\" type=\"text\" name=\"cm_doclogo_height\" size=\"6\" maxlength=\"10\" value=\"$cm_doclogo_height\">";
    echo "</td><td class=\"config1body2\">48x48</td><td class=\"config1body2\">\n";
    echo "{$cm_text["setup-images_doclogosize"]} <br>";
    echo "</td></tr>\n";
    echo "</table>\n";

    echo "<hr><input class=\"cms\" type=\"submit\" name=\"cm_setup\" value=\"{$cm_text["setup-setup"]}\">
    <input class=\"cms\" type=\"submit\" name=\"cm_cancel\" value=\"{$cm_text["setup-cancel"]}\">
    <BR>&nbsp;<br>
    </form>
    ";
  }
}


if ($cmru) {
  echo "<p class=\"setupreturn\"><a class=\"cms\"href=\"" . $cmru . ".php\">{$cm_text["setup-return"]}</a></p>";
}


echo "</body></html>";
?>